import win32.windows;
import win32.windef;
import win32.commctrl;
import std.stdio;
import std.string;
import std.utf;

import Spin;
import GraphicBaseEx;

T SGN(T)(T a) { return( a<0 ? -1 : a>0 ? 1 : 0 ) ;}

class GraphicFrameTest : GraphicBaseEx {
  Spin scalespin ;

  this(string name, string ClassName) {
    super(name,ClassName) ;
  }

  override int wm_create(){
    return(0) ;
  }

  override int wm_paint(){
    return(0) ;
  }

  override int wm_size(int w, int h){
    return(0) ;
  }

  override int wm_mousewheel(int d, int key){
    if( (key & MK_CONTROL) !=0 ){
      if( d!=0 ){
        double scale = scalespin.getValue() * (1.0+getZoomrate()*SGN(cast(double)(d)/120.0)) ;
        scaling(scale/100.0) ;
        scalespin.setValue(scale) ;
      }
      return(1) ;
    }
    return(0) ;
  }

  override int mouse( int acs_stat, int mb, int mx, int my ){
    int w = getImageBufferWidth() ;
    int h = getImageBufferHeight() ;
    uint[][] imgbuf = getImageBuffer() ;
    if( my<h && mx<w && my>=0 && mx>=0 && (mb & LBUTTONDOWN)!=0  ){
      imgbuf[my][mx]=0xff000000 ;
    }
    return(1) ;
  }

  override int keyboard(int type, int acs, int key, int mousex, int mousey){
    if( type==0 ){
      switch(key){
      case 'o': scaling(1.0) ; break ;
      case 'f': fitting(true,true)  ; break ;
      case 'w': fitting(true,false) ; break ;
      case 'h': fitting(false,true) ; break ;
      default :
        return(0) ;
        break ;
      }
    }
    return(1) ;
  }

  int scaling(double scale=1.0, bool step=false){
    if( step==true ){
      double dispscale=getScale() ;
      dispscale *= 1.0+getZoomrate()*SGN(scale) ;
      setScale(dispscale,true) ;
      scalespin.setValue(dispscale*100.0) ;
    }else{
      setScale(scale) ;
      scalespin.setValue(scale*100.0) ;
    }
    return(0) ;
  }

  int fitting(bool fitw=true, bool fith=true){
    for( int i=0 ; i<2 ; i++ ){
      double ww=getWindowWidth() ;
      double wh=getWindowHeight() ;
      double iw=getImageBufferWidth() ;
      double ih=getImageBufferHeight() ;
      if( fitw==true && fith==true ){
        if( ww>0.0 && wh>0.0 && iw>0.0 && ih>0.0 ){
          if( ww/iw*ih>=wh ){
            scaling(wh/ih) ;
          }else{
            scaling(ww/iw) ;
          }
        }
      }else if( fitw==true && fith==false ){
        if( ww>0.0 && iw>0.0 ){
          scaling(ww/iw) ;
        }
      }else if( fitw==false && fith==true ){
        if( wh>0.0 && ih>0.0 ){
          scaling(wh/ih) ;
        }
      }
    }
    return(0) ;
  }

  int setScaleSpin(Spin scalespin){
    if( scalespin !is null ){
      this.scalespin = scalespin ;
    }
    return(0) ;
  }
}
