import win32.windows;
import win32.windef;
import win32.commctrl;
import win32frame.Frame;
import win32frame.WindowMenu;
import win32frame.StatusBar;
import win32frame.ToolBarEx;
import win32frame.Rebar;
import win32frame.PushButton;
import win32frame.MainWindow ;
import win32frame.MsgBox;
import win32frame.FileDialog;
import win32frame.FontSelDialog ;
import win32frame.ColorSelDialog ;
import std.stdio;
import std.string;
import std.utf;

import FontMan;
import TestDialog;
import MyButton ;
import MainPanel ;

enum FILE{
  ROOT  =0x100,
  OPEN  =0x101,
  CLOSE =0x102,
  EXIT  =0x103
} ;
enum EDIT{
  ROOT  =0x200,
  CUT   =0x201,
  COPY  =0x202,
  PASTE =0x203
} ;
enum TEST{
  ROOT  =0x300,
  TEST1 =0x301,
  TEST2 =0x302,
  TEST3 =0x303
} ;

enum CMD{
  OPENTESTDLG    =0xa00,
  OPENFONTSELDLG =0xa01,
  OPENCOLSELDLG  =0xa02,
} ;

enum TOOLBAR{
  ROOT    =0x500,
  NEWFILE =0x501,
  FOPEN   =0x502,
  FSAVE   =0x503,
  ECOPY   =0x504,
  ECUT    =0x505,
  EDEL    =0x506
} ;


class myMainWindow : MainWindow {
  WindowMenu  menuroot ;
  StatusBar   statusbar ;
  ToolBarEx   toolbarex ;
  TBBUTTON[]  tbbtn ;
  MainPanel   mainpanel ;
  MyButton    tdlogbtn ;
  MyButton    fontselbtn ;
  MyButton    colselbtn ;

  HFONT       hfont_v14;
  HFONT       selfont ;
  FontMan     FontSel ;
  bool        test1stat =false ;
  bool        test23stat=false ;

  this(string name, string ClassName) {
    winc.style          = 0;
    winc.cbClsExtra     = 0;
    winc.cbWndExtra     = 0;
    winc.hIcon          = LoadIcon(GetModuleHandle(null), toUTFz!(wchar*)("WAPICON"));
    winc.hCursor        = LoadCursor(null , cast(wchar*)(IDC_ARROW));
    //winc.hbrBackground  = CreateSolidBrush(GetSysColor(COLOR_BTNFACE)) ;
    winc.lpszMenuName   = null;
    winc.lpszClassName  = toUTFz!(wchar*)(ClassName) ;
    super(name,ClassName) ;

    tbbtn.length = 7 ;
    tbbtn[0].iBitmap=STD_FILENEW  ; tbbtn[0].idCommand=TOOLBAR.NEWFILE ; tbbtn[0].fsState=TBSTATE_ENABLED ; tbbtn[0].fsStyle=TBSTYLE_BUTTON ;
    tbbtn[1].iBitmap=STD_FILEOPEN ; tbbtn[1].idCommand=TOOLBAR.FOPEN   ; tbbtn[1].fsState=TBSTATE_ENABLED ; tbbtn[1].fsStyle=TBSTYLE_BUTTON ;
    tbbtn[2].iBitmap=STD_FILESAVE ; tbbtn[2].idCommand=TOOLBAR.FSAVE   ; tbbtn[2].fsState=TBSTATE_ENABLED ; tbbtn[2].fsStyle=TBSTYLE_BUTTON ;
    tbbtn[3].iBitmap=0            ; tbbtn[3].idCommand=0               ; tbbtn[3].fsState=TBSTATE_ENABLED ; tbbtn[3].fsStyle=TBSTYLE_SEP    ;
    tbbtn[4].iBitmap=STD_COPY     ; tbbtn[4].idCommand=TOOLBAR.ECOPY   ; tbbtn[4].fsState=TBSTATE_ENABLED ; tbbtn[4].fsStyle=TBSTYLE_BUTTON ;
    tbbtn[5].iBitmap=STD_CUT      ; tbbtn[5].idCommand=TOOLBAR.ECUT    ; tbbtn[5].fsState=TBSTATE_ENABLED ; tbbtn[5].fsStyle=TBSTYLE_BUTTON ;
    tbbtn[6].iBitmap=STD_DELETE   ; tbbtn[6].idCommand=TOOLBAR.EDEL    ; tbbtn[6].fsState=TBSTATE_ENABLED ; tbbtn[6].fsStyle=TBSTYLE_BUTTON ;

    FontSel.init(-12,FIXED_PITCH,"ＭＳ ゴシック") ;
  }

  override LRESULT proc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch (msg) {
    case WM_DESTROY:
      DeleteObject(hfont_v14);
      DeleteObject(selfont) ;
      PostQuitMessage(0);
      break ;

    case WM_CREATE:
      menuroot = new WindowMenu() ;
      menuroot.create() ;
      menuroot.addMenu(             MFT_STRING, "File"     , FILE.ROOT ) ;
      menuroot.addItem( "File",     MFT_STRING, "Open"     , FILE.OPEN ) ;
      menuroot.addItem( "File",     MFT_STRING, "Close"    , FILE.CLOSE) ;
      menuroot.addItem( "File",     MFT_STRING, "Exit"     , FILE.EXIT ) ;
      menuroot.addMenu(             MFT_STRING, "Edit"     , EDIT.ROOT ) ;
      menuroot.addItem( "Edit",     MFT_STRING, "Cut"      , EDIT.CUT  ) ;
      menuroot.addItem( "Edit",     MFT_STRING, "Copy"     , EDIT.COPY ) ;
      menuroot.addItem( "Edit",     MFT_STRING, "Paste"    , EDIT.PASTE) ;
      menuroot.addMenu(             MFT_STRING, "Test"     , TEST.ROOT ) ;
      menuroot.addItem( "Test",     MFT_STRING,                "Test1" , TEST.TEST1) ;
      menuroot.addItem( "Test",     MFT_STRING|MFT_RADIOCHECK, "Test2" , TEST.TEST2) ;
      menuroot.addItem( "Test",     MFT_STRING|MFT_RADIOCHECK, "Test3" , TEST.TEST3) ;

      setMenu(menuroot) ;

      statusbar = new StatusBar() ;
      statusbar.addStyle(CCS_BOTTOM | SBARS_SIZEGRIP) ;
      addStatusBar(statusbar, "") ;

      FontMan font_v14 ; font_v14.init(-14,VARIABLE_PITCH) ;
      hfont_v14 = font_v14.createHFONT() ;

      selfont = FontSel.createHFONT() ;

      toolbarex = new ToolBarEx() ;
      toolbarex.addStyle(CCS_ADJUSTABLE|TBSTYLE_FLAT|CCS_NOPARENTALIGN|CCS_NORESIZE|CCS_NODIVIDER) ;
      toolbarex.create(hwnd, TOOLBAR.ROOT, 0, tbbtn, cast(int)(tbbtn.length)) ;
      REBARBANDINFO rbbi ;
      rbbi.fMask = RBBIM_BACKGROUND | RBBIM_STYLE | RBBIM_CHILD | RBBIM_CHILDSIZE | RBBIM_SIZE ;
      rbbi.cxMinChild = 20 ;
      rbbi.cyMinChild = 25 ;
      rbbi.cx         = 160 ;
      setREBARBANDINFO(rbbi) ;
      addonRebar(toolbarex) ;

      tdlogbtn= new MyButton("OpenTestDialog") ;
      tdlogbtn.setPosition(0,20,100,20) ;
      //tdlogbtn.setFlatMode(true) ;
      addObject(tdlogbtn, cast(HMENU)(CMD.OPENTESTDLG)) ;
      rbbi.cx         = 140 ;
      setREBARBANDINFO(rbbi) ;
      addonRebar(tdlogbtn) ;
      tdlogbtn.setFont(hfont_v14) ;

      fontselbtn= new MyButton("FontSelectDialog") ;
      fontselbtn.setPosition(0,20,100,20) ;
      fontselbtn.setFlatMode(true,true) ;
      addObject(fontselbtn, cast(HMENU)(CMD.OPENFONTSELDLG)) ;
      addonRebar(fontselbtn) ;
      fontselbtn.setFont(selfont) ;

      colselbtn= new MyButton("ColSelectDialog") ;
      colselbtn.setPosition(0,20,100,20) ;
      colselbtn.setFlatMode(true,true) ;
      addObject(colselbtn, cast(HMENU)(CMD.OPENCOLSELDLG)) ;
      addonRebar(colselbtn) ;
      colselbtn.setFont(hfont_v14) ;

      mainpanel = new MainPanel("MainPanel","MainPanelTest") ;
      mainpanel.setPosition(0,0,200,200) ;
      mainpanel.setStyle( WS_CHILD |WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE ) ;
      addObject( mainpanel, null, true, true ) ;

      SetLayeredWindowAttributes(hwnd, 0, 255, LWA_ALPHA);
      break ;

    case WM_INITMENU:
      menuroot.checkItem("Test",TEST.TEST1, test1stat ) ;
      menuroot.checkItem("Test",TEST.TEST2, test23stat) ;
      menuroot.checkItem("Test",TEST.TEST3,!test23stat) ;
      break ;

    case WM_COMMAND:
      switch( LOWORD(wp) ){
      case TOOLBAR.FOPEN :
      case FILE.OPEN :
        FileDialog fdlog = new FileDialog() ;
        string     fname ;
        fname=fdlog.getLoadFileName("JPEG {*.JPG}\0*.jpg\0"
                                    "PNG {*.PNG}\0*.png\0"
                                    "TGA {*.TGA}\0*.tga\0"
                                    "BMP {*.BMP}\0*.bmp\0"
                                    "PBM {*.PBM}\0*.pbm\0"
                                    "PGM {*.PGM}\0*.pgm\0"
                                    "PPM {*.PPM}\0*.ppm\0",
                                    hwnd,OFN_HIDEREADONLY) ;
        if( fname.length!=0 ){
          if( this.mainpanel.subpanel2.LoadImage(fname)==0 ){
            printStatusbar( format("%sを開きました",fname) ) ;
          }else{
            printStatusbar( format("%sのロードに失敗しました",fname) ) ;
          }
        }
        break ;

      case FILE.EXIT :
        int    msgbox_ret ;
        MsgBox msgbox ;
        msgbox = new MsgBox(hwnd, "終了しますか？", "確認", MB_YESNO ) ;
        msgbox_ret = msgbox.create() ;
        if( msgbox_ret==IDYES ){
          sendmsg(WM_CLOSE, 0,0) ;
        }
        break ;

      case CMD.OPENTESTDLG :
        auto dlogbox = new TestDialog("TestDialog", "DialogBox") ;
        dlogbox.Create( winX+100, winY+100, hwnd, null ) ;
        int dlgret = dlogbox.getDlogResult() ;
        int chkret = dlogbox.getCheckState() ;
        double spinvalue = dlogbox.getSpinValue() ;
        printStatusbar( format("dlog_result=%x / CheckState=%x / SpinValue=%f",dlgret,chkret,spinvalue) ) ;
        destroy(dlogbox) ;
        break ;

      case CMD.OPENFONTSELDLG :
        CHOOSEFONT cf ;
        cf.lpLogFont = &FontSel.lf ;
        cf.hwndOwner = hwnd ;
        cf.Flags     = CF_NOVERTFONTS | CF_SCREENFONTS | CF_INITTOLOGFONTSTRUCT ; //| CF_FIXEDPITCHONLY |   CF_SELECTSCRIPT ;
        auto fsdlog = new FontSelDialog() ;
        if( fsdlog.chooseFont(&cf)==true ){
          wchar[] wstr ; wstr.length = cf.lpLogFont.lfFaceName.length ;
          for( int i=0 ; i<wstr.length ; i++ ){
            if( cf.lpLogFont.lfFaceName[i]=='\0' ){ wstr.length=i ; break ; }
            wstr[i]=cf.lpLogFont.lfFaceName[i] ;
          }
          printStatusbar((format("%s , %d",toUTF8(wstr.idup), cf.lpLogFont.lfHeight))) ;
          if( selfont!=null ) DeleteObject(selfont) ;
          selfont = FontSel.createHFONT() ;
          fontselbtn.setFont(selfont) ;
        }
        break ;

      case CMD.OPENCOLSELDLG :
        CHOOSECOLOR  cc ;
        COLORREF     color ;
        COLORREF[16] collist ;
        cc.hwndOwner = hwnd ;
        cc.Flags     = CC_FULLOPEN | CC_RGBINIT | CC_PREVENTFULLOPEN ;
        cc.rgbResult = color ;
        cc.lpCustColors = collist.ptr ;
        auto colsel = new ColorSelDialog() ;
        if( colsel.chooseColor(&cc)==true ){
          colselbtn.setStringColor(cc.rgbResult) ;
        }
        break ;

      case TOOLBAR.NEWFILE :
        printStatusbar( "ToolBar NewFile" ) ;
        break ;
      case TOOLBAR.FSAVE :
        printStatusbar( "ToolBar FileSave" ) ;
        break ;
      case TOOLBAR.ECOPY :
        printStatusbar( "ToolBar Copy" ) ;
        break ;
      case TOOLBAR.ECUT :
        printStatusbar( "ToolBar Cut" ) ;
        break ;
      case TOOLBAR.EDEL :
        printStatusbar( "ToolBar Delete" ) ;
        break ;

      case FILE.CLOSE :
        printStatusbar( "Menu File Close" ) ;
        break ;
      case EDIT.CUT :
        printStatusbar( "Menu Edit Cut" ) ;
        break ;
      case EDIT.COPY :
        printStatusbar( "Menu Edit Copy" ) ;
        break ;
      case EDIT.PASTE :
        printStatusbar( "Menu Edit Paste" ) ;
        break ;

      case TEST.TEST1 :
        test1stat = !test1stat ;
        menuroot.checkItem("Test",TEST.TEST1, test1stat) ;
        SetLayeredWindowAttributes(hwnd, 0, test1stat==true ? 192 : 255, LWA_ALPHA);
        printStatusbar( "Menu Test.Test1 " ~ (test1stat==true ? "to True(semitransparent)" : "to False") ) ;
        break ;

      case TEST.TEST2 :
        test23stat = true ;
        menuroot.checkItem("Test",TEST.TEST2, test23stat) ;
        menuroot.checkItem("Test",TEST.TEST3,!test23stat) ;
        printStatusbar( "Menu Test.Test2 " ~ (test23stat==true ? "to True" : "to False") ~ ", " ~
                        "Menu Test.Test3 " ~ (test23stat==false? "to True" : "to False") ) ;
        break ;
      case TEST.TEST3 :
        test23stat = false ;
        menuroot.checkItem("Test",TEST.TEST2, test23stat) ;
        menuroot.checkItem("Test",TEST.TEST3,!test23stat) ;
        printStatusbar( "Menu Test.Test2 " ~ (test23stat==true ? "to True" : "to False") ~ ", " ~
                        "Menu Test.Test3 " ~ (test23stat==false? "to True" : "to False") ) ;
        break ;

      default :
        break ;
      }
      break;

    default :
      return( DefWindowProc(hwnd , msg , wp , lp) );
    }
    return(0);
  }
}
