import win32.windows;
import std.stdio;
import std.string;
import win32frame.writek;
import win32frame.WindowObject ;
import win32frame.MsgTranslator;

class DialogBoxClass : WindowObject {
  bool is_modeless=false ;
  int  dialog_res ;
  int  dialog_exit ;
  HWND phwnd ;

  this( string name ) {
    this.dialog_res      = 0 ;
    this.dialog_exit     = 0 ;
    this.winc.cbWndExtra = DLGWINDOWEXTRA ;
    super(name) ;
  }

  int create( DWORD style, int x, int y, int width, int height, HWND phwnd, HMENU hmenu){
    this.phwnd=phwnd ;
    int res ;
    MSG msg;

    this.registwinc() ;
    res=lowcreate( WS_EX_DLGMODALFRAME,
                   style, x, y, width, height, phwnd, hmenu ) ;
    if( res==0 ){
      while(this.dialog_exit==0) {
        GetMessage(&msg,null,0,0);
        if(IsDialogMessage(this.getHWND(),&msg)==0){
          if( is_modeless==true ){
            TranslateMessage(&msg);
            DispatchMessage(&msg);
          }else{
            switch( msg.message ){
            case WM_SYSCOMMAND :
              TranslateMessage(&msg);
              DispatchMessage(&msg);
              SetFocus(this.getHWND()) ;
              break ;
            default :
              if( (msg.message & 0xfff0)==0x200 ){ //MouseEvents
                if( msg.message==WM_LBUTTONDOWN || msg.message==WM_RBUTTONDOWN || msg.message==WM_MBUTTONDOWN ){
                  MessageBeep(MB_OK) ;
                  SetFocus(this.getHWND()) ;
                }
                break ;
              }
              if( msg.message>=WM_NCMOUSEMOVE && msg.message<=WM_NCMBUTTONDBLCLK ){
                if( msg.wParam!=HTCAPTION ) break ;
              }
              TranslateMessage(&msg);
              DispatchMessage(&msg);
              break ;
            }
          }
        }
      }
    }else{
      return(res) ;
    }
    return( this.dialog_res ) ;
  }

  override LRESULT proc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    return( DefDlgProc(hwnd , msg , wp , lp) );
  }

  void setModeless(){
    is_modeless=true ;
  }

  void setResult(int res){
    this.dialog_res=res ;
    this.dialog_exit=1 ;
  }

  int getDlogState(){
    return(this.dialog_exit) ;
  }

  int getDlogResult(){
    return(this.dialog_res) ;
  }
}
